'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator;

function _load_regenerator() {
  return _regenerator = _interopRequireDefault(require('babel-runtime/regenerator'));
}

var _assign;

function _load_assign() {
  return _assign = _interopRequireDefault(require('babel-runtime/core-js/object/assign'));
}

var _keys;

function _load_keys() {
  return _keys = _interopRequireDefault(require('babel-runtime/core-js/object/keys'));
}

var _getIterator2;

function _load_getIterator() {
  return _getIterator2 = _interopRequireDefault(require('babel-runtime/core-js/get-iterator'));
}

var _asyncToGenerator2;

function _load_asyncToGenerator() {
  return _asyncToGenerator2 = _interopRequireDefault(require('babel-runtime/helpers/asyncToGenerator'));
}

var promptForCredentials = function () {
  var _ref = (0, (_asyncToGenerator2 || _load_asyncToGenerator()).default)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee(appleCtx, types) {
    var printWarning = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;

    var credentials, metadata, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, type, value, _constants$CREDENTIAL, name, required, questions, _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, i, question, answer, valueKeys;

    return (_regenerator || _load_regenerator()).default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (printWarning) {
              (0, (_log || _load_log()).default)(EXPERT_PROMPT);
            }
            credentials = {};
            metadata = {};
            _iteratorNormalCompletion = true;
            _didIteratorError = false;
            _iteratorError = undefined;
            _context.prev = 6;
            _iterator = (0, (_getIterator2 || _load_getIterator()).default)(types);

          case 8:
            if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
              _context.next = 53;
              break;
            }

            type = _step.value;
            value = {};
            _constants$CREDENTIAL = (_constants || _load_constants()).CREDENTIALS[type], name = _constants$CREDENTIAL.name, required = _constants$CREDENTIAL.required, questions = _constants$CREDENTIAL.questions;

            (0, (_log || _load_log()).default)('Please provide your ' + name + ':');
            _iteratorNormalCompletion2 = true;
            _didIteratorError2 = false;
            _iteratorError2 = undefined;
            _context.prev = 16;
            _iterator2 = (0, (_getIterator2 || _load_getIterator()).default)(required);

          case 18:
            if (_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done) {
              _context.next = 28;
              break;
            }

            i = _step2.value;
            question = questions[i];
            _context.next = 23;
            return _askQuestionAndProcessAnswer(question);

          case 23:
            answer = _context.sent;

            value[i] = answer;

          case 25:
            _iteratorNormalCompletion2 = true;
            _context.next = 18;
            break;

          case 28:
            _context.next = 34;
            break;

          case 30:
            _context.prev = 30;
            _context.t0 = _context['catch'](16);
            _didIteratorError2 = true;
            _iteratorError2 = _context.t0;

          case 34:
            _context.prev = 34;
            _context.prev = 35;

            if (!_iteratorNormalCompletion2 && _iterator2.return) {
              _iterator2.return();
            }

          case 37:
            _context.prev = 37;

            if (!_didIteratorError2) {
              _context.next = 40;
              break;
            }

            throw _iteratorError2;

          case 40:
            return _context.finish(37);

          case 41:
            return _context.finish(34);

          case 42:
            valueKeys = (0, (_keys || _load_keys()).default)(value);

            credentials[type] = valueKeys.length === 1 ? value[valueKeys[0]] : value;
            _context.t1 = (_assign || _load_assign()).default;
            _context.t2 = metadata;
            _context.next = 48;
            return _calculateMetadata(credentials[type]);

          case 48:
            _context.t3 = _context.sent;
            (0, _context.t1)(_context.t2, _context.t3);

          case 50:
            _iteratorNormalCompletion = true;
            _context.next = 8;
            break;

          case 53:
            _context.next = 59;
            break;

          case 55:
            _context.prev = 55;
            _context.t4 = _context['catch'](6);
            _didIteratorError = true;
            _iteratorError = _context.t4;

          case 59:
            _context.prev = 59;
            _context.prev = 60;

            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }

          case 62:
            _context.prev = 62;

            if (!_didIteratorError) {
              _context.next = 65;
              break;
            }

            throw _iteratorError;

          case 65:
            return _context.finish(62);

          case 66:
            return _context.finish(59);

          case 67:
            return _context.abrupt('return', [credentials, metadata]);

          case 68:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this, [[6, 55, 59, 67], [16, 30, 34, 42], [35,, 37, 41], [60,, 62, 66]]);
  }));

  return function promptForCredentials(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

var _askQuestionAndProcessAnswer = function () {
  var _ref2 = (0, (_asyncToGenerator2 || _load_asyncToGenerator()).default)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee2(definition) {
    var questionObject, _ref3, input;

    return (_regenerator || _load_regenerator()).default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            questionObject = _buildQuestionObject(definition);
            _context2.next = 3;
            return (0, (_prompt2 || _load_prompt()).default)(questionObject);

          case 3:
            _ref3 = _context2.sent;
            input = _ref3.input;
            _context2.next = 7;
            return _processAnswer(definition, input);

          case 7:
            return _context2.abrupt('return', _context2.sent);

          case 8:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function _askQuestionAndProcessAnswer(_x4) {
    return _ref2.apply(this, arguments);
  };
}();

var _processAnswer = function () {
  var _ref5 = (0, (_asyncToGenerator2 || _load_asyncToGenerator()).default)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee3(_ref6, input) {
    var type = _ref6.type,
        base64Encode = _ref6.base64Encode;
    return (_regenerator || _load_regenerator()).default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            if (!(type === 'file')) {
              _context3.next = 4;
              break;
            }

            return _context3.abrupt('return', (_fsExtra || _load_fsExtra()).default.readFile(input, base64Encode ? 'base64' : 'utf8'));

          case 4:
            return _context3.abrupt('return', input);

          case 5:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));

  return function _processAnswer(_x5, _x6) {
    return _ref5.apply(this, arguments);
  };
}();

var _calculateMetadata = function () {
  var _ref7 = (0, (_asyncToGenerator2 || _load_asyncToGenerator()).default)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee4(_ref8) {
    var certP12 = _ref8.certP12,
        certPassword = _ref8.certPassword;
    var distCertSerialNumber;
    return (_regenerator || _load_regenerator()).default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            if (certP12 && certPassword) {
              _context4.next = 2;
              break;
            }

            return _context4.abrupt('return', null);

          case 2:
            distCertSerialNumber = (_xdl || _load_xdl()).IosCodeSigning.findP12CertSerialNumber(certP12, certPassword);
            return _context4.abrupt('return', { distCertSerialNumber: distCertSerialNumber });

          case 4:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, this);
  }));

  return function _calculateMetadata(_x7) {
    return _ref7.apply(this, arguments);
  };
}();

var _untildify;

function _load_untildify() {
  return _untildify = _interopRequireDefault(require('untildify'));
}

var _path = _interopRequireDefault(require('path'));

var _xdl;

function _load_xdl() {
  return _xdl = require('@expo/xdl');
}

var _fsExtra;

function _load_fsExtra() {
  return _fsExtra = _interopRequireDefault(require('fs-extra'));
}

var _constants;

function _load_constants() {
  return _constants = _interopRequireWildcard(require('../constants'));
}

var _log;

function _load_log() {
  return _log = _interopRequireDefault(require('../../../../../log'));
}

var _prompt2;

function _load_prompt() {
  return _prompt2 = _interopRequireDefault(require('../../../../../prompt'));
}

var _validators;

function _load_validators() {
  return _validators = _interopRequireWildcard(require('../../../../utils/validators'));
}

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var EXPERT_PROMPT = '\nWARNING! In this mode, we won\'t be able to make sure your Distribution Certificate,\nPush Notifications service key or Provisioning Profile are valid. Please double check\nthat you\'re uploading valid files for your app otherwise you may encounter strange errors!\n\nMake sure you\'ve created your app ID on the developer portal, that your app ID\nis in app.json as `bundleIdentifier`, and that the provisioning profile you\nupload matches that team ID and app ID.\n';

function _buildQuestionObject(_ref4) {
  var type = _ref4.type,
      question = _ref4.question;

  var inputType = type === 'password' ? 'password' : 'input';
  var questionObject = {
    type: inputType,
    name: 'input',
    message: question
  };

  if (type === 'file') {
    questionObject.filter = _produceAbsolutePath;
    questionObject.validate = (_validators || _load_validators()).existingFile;
  } else {
    questionObject.validate = (_validators || _load_validators()).nonEmptyInput;
  }

  return questionObject;
}

var _produceAbsolutePath = function _produceAbsolutePath(filePath) {
  var untildified = (0, (_untildify || _load_untildify()).default)(filePath.trim());
  return !_path.default.isAbsolute(untildified) ? _path.default.resolve(untildified) : untildified;
};

exports.default = promptForCredentials;
module.exports = exports['default'];
//# sourceMappingURL=../../../../../__sourcemaps__/commands/build/ios/credentials/prompt/promptForCredentials.js.map
